ZPADDR	EQU	$30			;POINTER TO SET THE START BYTE LOCATION FOR THE 2 BYTE MEM ADDRESS (WHICH WILL STORE THE STRINGS MEMORY START AT $0030 AND $0031)
MONHEX	EQU	$DA			;MEMORY ADDRESS $DA=MEM ADDRESS,$DB=HEX VALUE OF MEM ADDRESS,$DC=MSN OF $DA,$DD=LSN OF $DA,$DE=MSN OF $DA,$DF=LSN OF $DA (SEE PMONITOR SUB)
KENTER	EQU	$0D			;ENTER KEY ON KEYBOARD IS #0D
CR		EQU	$0D			;CR $0D IS CARRIAGE RETURN

GETIN	EQU $FFE4		;GETIN reads a single byte from default input
						;returns #0 if no key is pressed = non-blocking
CLOCKAPI	EQU $FF50	;COMMANDER X16 KERNAL_API CALL CLOCK_GET_DATE_TIME, RESULT: YEAR=$02,MONTH=$03,DAY=$04,HOURS=$05,MINUTES=$06,SECONDS=$07,JIFFIES=$08.
CLOCKSEC	EQU $07
;---------------------------------------------
;COMMANDER X16 - HANGMAN - MEMORY MAP SUMMERIZED
;---------------------------------------------
;$0000 - $000F 		!COMMANDER X16 VARIABLES USED BY THE NEW API CALLS. TRY NOT TO USE.
;$0010 - $002F		CHARACTER BUFFER FOR USER TYPED TEXT (30 CHAR MAX)
;$0030 - $0044 		TEMP DATA USED BY VARIOUS FUNCTIONS AND SUBROUTINES, NO FIXED ASSIGNMENT. (ZPADDR)
;$0030 - $007D		VARIABLES USED BY HANGMAN, FIXED ASSIGNMENTS. 
;$007E - $007F		RANDOMIZER SEED VARIABLES

;$0080 - $00FF		!COMMANDER X16 KERNAL AND BASIC ZERO PAGE VARIABLES, DO NOT USE! CAN BE USED IN ASM THAT ONLY USES KERNAL, NO BASIC OR FLOATING POINT.
;* $00C0 - $00D0	USED BY CHIBIAKUMAS Z_REGS VARIABLES (BASICFUNCTIONS.ASM) THAT ARE USED AS A BASE FOR THIS PROGRAM (17 BYTES)
;* $00DA - $00DF	USED MY MONHEX ROUTINE

;$0100 - $01FF		!6502 CPU STACK VALUES, DO NOT USE!
;$0200 - $03FF		!COMMANDER X16 KERNAL AND BASIC VARIABLES AND VECTORS, DO NOT USE!
;$0400 - $0434		MORE VARIABLES WITH FIXED ASSIGNMENTS
;$0435 - $043F		** FREE / UNUSED **
;$0440 - $04DC		HANGMAN DRAW ARRAY
;$04DD - $04FD		MORE VARIABLES WITH FIXED ASSIGNMENTS
;$04FE - $0800		** FREE / UNUSED **
;$0801 - 			ASSEMBLED PROGRAM CODE

;$9F00 - $9FFF		!COMMANDER X16 I/O AREA (256 BYTES), DO NOT USE!
;$A000 - $BFFF		!COMMANDER X16 BANKED RAM (8KB WINDOW, 256 BANKS AVAILABLE, TOTAL 2 MB)
;$C000 - $FFFF		!COMMANDER X16 BANKED ROM (16KB WINDOW, 8 BANKS AVAILABLE, TOTAL 128 KB)
;* $FF62 - $FFF3	!COMMANDER X16, KERNAL API CALLS FOR COMMODORE 64/128 COMPATIBILITY.!

;---------------------------------------------
; $00.$0F - USED AS TEMP DATA IN A FUNCTION/SUBROUTINE
; $10.$2F - USED TO STORE PLAYER TYPED TEXT (MAX 30 CHARACHTERS, MUST END WITH VALUE 00 AFTER LAST LETTER). $2F CONTAINS AMOUNT OF LETTERS!
CHRBUF	EQU	$10
CHRBUFC	EQU	$2F
; -- ALL OF HANGMANS VARIABLES!!
VAR_AS	EQU	$04DD	; $04DD.$04FD 		A$ = VARIABLE CONTAINING THE WORD TO GUESS (MAX 20 CHARACTERS), PLUS A 0 AT THE END
VAR_GS	EQU	$45		; $45.$46 		G$ = STORES THE LETTER CURRENTLY GUESSED BY THE PLAYER (1 CHAR, PLUS A 0 AT THE END)
VAR_NS	EQU	$47		; $47.$61 		N$(26) = ARRAY FOR LETTERS ALREADY TRIED, PLUS A 0 AT THE END
VAR_DS	EQU	$62		; $62.$76 		D$(20) = ARRAY STORING WORD TO SHOW PROGESS ON SCREEN (STARTS WITH - IN ALL, REPLACED WITH LETTERS IF A GOOD LETTER IS GUESSED), PLUS A 0 AT THE END
VAR_T1	EQU	$77		; $77			T1 = NUMBER OF GUESSES THE PLAYER USED FOR THIS WORD
VAR_L	EQU	$78		; $78			L = LENGTH OF THE WORD TO GUESS
VAR_M	EQU	$79		; $79 			M = COUNTER FOR THE NUMBER OF FAILED LETTERS GUESSES
VAR_C	EQU	$7A		; $7A			C = NUMBER OF WORDS GUESSED ALREADY
VAR_N	EQU	$7B		; $7B			N = NUMBER OF POSSIBLE WORDS TO USE
VAR_Q	EQU	$7C		; $7C			Q = THE RANDOM NUMBER FOR THIS WORD
VAR_R	EQU	$7D		; $7D			R = THE NUMBER OF TIMES THE LETTERS GUESSED IS FOUND IN THE WORD TO GUESS
VAR_U	EQU $0400	; $0400.$0432	U(50) = ARRAY WHICH STORES THAT WORDS ARE ALREADY GUESSED (0 = NOT GUESSED, 1 = GUESSED), PLUS A 0 AT THE END
				
SEED	EQU	$7E		; ZERO PAGE $7E - USED FOR RANDOM NUMBER GENERATOR SEED ($7F ALSO RESERVED JUST IN CASE)

VAR_PS		EQU	$0440		; $0440.04DA	P$(12,12) = M_ARRAY USED TO STORE THE DRAWED CHARACTERS OF THE HANGMAN 
VAR_PS1		EQU	$0440		; ROW 1 : 0440 - 044B (PLUS 044C FOR CARRIAGE RETURN)
VAR_PS2		EQU	$044D		; ROW 2 : 044D - 0458 (PLUS 0459 FOR CARRIAGE RETURN) 
VAR_PS3		EQU	$045A		; ROW 3 : 045A - 0465 (PLUS 0466 FOR CARRIAGE RETURN)	
VAR_PS4		EQU	$0467		; ROW 4 : 0467 - 0472 (PLUS 0473 FOR CARRIAGE RETURN)
VAR_PS5		EQU	$0474		; ROW 5 : 0474 - 047F (PLUS 0480 FOR CARRIAGE RETURN)
VAR_PS6		EQU	$0481		; ROW 6 : 0481 - 048C (PLUS 048D FOR CARRIAGE RETURN)
VAR_PS7		EQU	$048E		; ROW 7 : 048E - 0499 (PLUS 049A FOR CARRIAGE RETURN)
VAR_PS8		EQU	$049B		; ROW 8 : 049B - 04A6 (PLUS 04A7 FOR CARRIAGE RETURN)
VAR_PS9		EQU	$04A8		; ROW 9 : 04A8 - 04B3 (PLUS 04B4 FOR CARRIAGE RETURN)
VAR_PS10	EQU	$04B5		; ROW 10: 04B5 - 04C0 (PLUS 04C1 FOR CARRIAGE RETURN)
VAR_PS11	EQU	$04C2		; ROW 11: 04C2 - 04CD (PLUS 04CE FOR CARRIAGE RETURN)
VAR_PS12	EQU	$04CF		; ROW 12: 04CF - 04DA (PLUS 04DB FOR CARRIAGE RETURN)
VAR_PSEND	EQU	$04DC		; END CHAR OF THE ARRAY IS $04DC WHICH HAS TO CONTAIN A 0 TO PRINT THE HANGMAN ON SCREEN PROPERLY

VAR_SEC		EQU	$0433		; LOCATION TO STORE PREVIOUS AMOUNT OF SECONDS
VAR_BLINK	EQU $0434		; IS THE BLINKING CURSOR ON OR OFF? (0=OFF/1=ON)

z_Regs equ $C0				; We need some Zeropage space for our work

	include "\srcAll\BasicMacros.asm"

	macro PushPair,ra	;Push a pair onto the stack (eg PushPair z_HL)
		lda \ra			
		pha				;Push lower Zpage entry
		lda \ra+1
		pha
	endm				;Push higher Zpage entry
	
	macro PullPair,ra	;Pull a pair onto the stack (eg PullPair z_HL)
		pla
		sta \ra+1		;Pull lower Zpage entry
		pla
		sta \ra			;Pull higher Zpage entry
	endm

SPpage equ $0100
	
	;These Register values are valid for Emulator R35 only!!
V_H  equ $9f22			;VERA_ADDR_HI  IIIIHHHH	20 Bit address H  I=Increment
V_M  equ $9f21			;VERA_ADDR_MID MMMMMMMM	20 Bit address M
V_L  equ $9f20			;VERA_ADDR_LO  LLLLLLLL	20 Bit address L
V_D1 equ $9f23			;VERA_DATA0    DDDDDDDD	Data Port 1

VERA_CTRL equ $9F25 	;$9F25 R------A   R=Reset A=Address (port 1 / 2)


*=$0801		
		;Alternative header (saves 3 bytes on the header above)
		BYTE $0B,$08,$01,$00,$9E,$32,$30,$36,$31,$00,$00,$00  ;Start at $080D
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Screen Setup
	
	     ;R------A		R=Reset A=Address (port 1 / 2)
	lda #%00000000
	sta VERA_CTRL  		 ;$9F25 - set ADDR0 active
	
	;Now to setup the display using the display composer (DC). The DC registers start at $F0000 (Emu R35!) = 1111 00000000 00000000
	lda #$1F    		;IIIIHHHH	20 Bit address H  I=Increment   00011111
	ldy #$00			;MMMMMMMM	20 Bit address M                00000000
	ldx #$00			;LLLLLLLL	20 Bit address L                00000000
	
	jsr SetVeraHML		;$F0000	DC_VIDEO                            1111 00000000 01000000
	
		 ;F----COO		F=current field (RO) 
	lda #%00000001		;C=Chroma disable O=Out mode (1=vga)	 
	sta V_D1 			;$F0000	DC_VIDEO 

	lda #64				; Hscale - 128=Normal 64=2x
	sta V_D1 			;$F0001	DC_HSCALE
	
	lda #64				; Vscale - 128=Normal 64=2x
	sta V_D1 			;$F0002	DC_VSCALE
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Palette Setup
	
	;We're going to setup up the palet. The pallet registers start at $F1000 (Emulator r35!) = 1111 00010000 00000000
	lda #$1F			;0001 1111
	ldy #$10			;0001 0000
	ldx #$00			;0000 0000
	jsr SetVeraHML		;$F1000	Color 0 Green/Blue

	ldx #2				;2 bytes x 256 entries ($GB $-R )
	ldy #0
	lda #<palette
	sta z_l
	lda #>palette
	sta z_h
	
PaletteLoop:	
	lda (z_hl),y		
	sta V_D1		
	iny
	bne PaletteLoop
	inc z_h
	dex
	bne PaletteLoop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Layer Setup
	;We're going to setup Layer 0 here. The registers for Layer 0 start at $F2000 (Emulator r35!)
	
	lda #$1F			;0001 1111
	ldy #$20			;0010 0000
	ldx #$00			;0000 0000
	jsr SetVeraHML		;$F2 00 00	L0_CTRL0 (Autoinc $01)
	
		 ;MMM----E M=Mode E=Enable
	lda #%11100001
	sta V_D1		;$F2000	L0_CTRL0		MMM----E	(M=Mode 7=8bpp bmp / E=Enable)
	
	stz V_D1		;$F2001	L0_CTRL1		--HWhhww	H=tile Height / W=tile Width / 
														;m=map height / w=map width
	stz V_D1		;$F2002	L0_MAP_BASE_L 	LLLLLLLL	Map Base (9:2)
	stz V_D1		;$F2003	L0_MAP_BASE_H	HHHHHHHH	Map Base (17:10)
	stz V_D1		;$F2004	L0_TILE_BASE_L 	LLLLLLLL	Tile Base (9:2)
	stz V_D1		;$F2005	L0_TILE_BASE_H  HHHHHHHH	Tile Base (17:10)
	stz V_D1		;$F2006	L0_HSCROLL_L	LLLLLLLL	Hscroll (7:0)
	stz V_D1		;$F2007	L0_HSCROLL_H 	----HHHH	Vscroll (11:8)
	stz V_D1		;$F2008	L0_VSCROLL_L  	LLLLLLLL	Hscroll (7:0)
	stz V_D1		;$F2009	L0_VSCROLL_H 	----HHHH	Vscroll (11:8)
	
	;Disable Layer 1, as it shows junk on the screen on top of layer 0
	lda #$1F			;0001 1111
	ldy #$30			;0011 0000
	ldx #$00			;0000 0000
	jsr SetVeraHML		;$F3 00 00	L1_CTRL0 (Autoinc $01)
	
	lda #%00000000
	sta V_D1		;$F3000 L1_CTRL0																
			
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	;CLEAR THE SCREEN, FILL IT WITH EMPTY CHARS (SPACEBARS)
	LDA #" "
	LDX #0
	LDY #0
CSRXLOOP
	JSR PrintChar		;PRINT SPACEBAR
	INX
	CPX #40				;CHECK IF 30 CHARACTERS HAVE BEEN PRINTED ON THE LINE ALREADY
	BEQ CSRXLOOPY
	CLV
	BVC CSRXLOOP		;OTHERWISE PRINT AGAIN
CSRXLOOPY
	;NOW CHECK IF WE CLEARED ENOUGH LINES
	CPY #25
	BEQ CSRYLOOPY
	INY
	LDX #0
	CLV
	BVC CSRXLOOP

CSRYLOOPY
	;CONTINUE WITH THE REST OF THE PROGRAM	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	;10  PRINT "HANGMAN"
	LDA #<OPENA			;PRINT THE INTRO TEXT ON SCREEN
	STA z_L
	LDA #>OPENA
	STA z_H
	JSR PrintString
	
	;30  DIM P$(12,12),L$(20),D$(20),N$(26),U(50)
	;CLEAR AND INITIALIZE VARIABLES
	LDX #<VAR_PS		;CLEAR MEMORY FROM VAR V_PS FOR 
	LDY #>VAR_PS
	LDA #156			;AND CLEAR THAT BYTE AND 155 AFTER THAT ONE (TOTAL 156 CLEARS)
	JSR CLRMEM
	LDA #255
	STA VAR_PSEND		;ALSO PUT A 0 AT THE END OF THE V_PS ARRAY, SO THE HANGMAN PRINTS PROPERLY.
	LDX #<VAR_AS			
	LDY #>VAR_AS
	LDA #21				;SAME FOR V_AS, BUT 20 CLEARS (PLUS 1 FOR 00 AT THE END)....
	JSR CLRMEM
	LDX #<VAR_DS			
	LDY #>VAR_DS
	LDA #21				;DITTO
	JSR CLRMEM
	LDX #<VAR_U			
	LDY #>VAR_U
	LDA #51		
	JSR CLRMEM			;DITTO
	;40 C = 1:N = 50
	LDA #1				;STORE VALUE 1 IN VARIABLE V_C
	STA VAR_C
	LDA #50				;STORE VALUE 50 IN VARIABLE V_N
	STA VAR_N
	
LINE50
	;50  FOR I = 1 TO 20:D$(I) = "-": NEXT I:M = 0
	LDX #<VAR_NS		;CLEAR V_NS (THIS WAS DONE IN LINE 40, BUT IT'S NOT CLEARED IF YOU PLAY A X-NT WORD.)
	LDY #>VAR_NS
	LDA #27
	JSR CLRMEM
	
	LDA #"-"			;STORE THE - CHARACTER IN A
	LDX #0				;STORE 0 IN LDX AS LOOP COUNTER
INIT_VDS	
	STA VAR_DS,X		;LOOP THROUGH V_DS WITH X AND OFFSET AND STORE '-' IN ALL MEMORY ADDRESSES, 20 TIMES.
	INX
	CPX #20
	BNE INIT_VDS
	LDA #0
	STA VAR_M
	
	;60  FOR I = 1 TO 26:N$(I) = "": NEXT I
	;WE DONT NEED TO DO ANYTHING, N$ IS ALREADY ZERO'ED OUT WHEN WE DID LINE 30.
	
	;70  FOR I = 1 TO 12: FOR J = 1 TO 12:P$(I,J) = " ": NEXT J: NEXT I
	LDX #0				;USE X REGISTER FOR MAIN LOOP THAT WILL PUT " " IN EVERY FIELD
	LDY #1				;USE Y REGISTER TO COUNT 0 TO 12, AT 12 PUT IN A CR INSTEAD OF " " SO WE CAN EASIALLY PRINT THE DRAW MATRIX ON SCREEN LATER
	LDA #" "
INIT_VPS	
	STA VAR_PS,X		;STORE " " SPACEBARS ON ALL 156 SPOTS IN THE HANGMANS DRAW MATRIX
	CPY #13				;IF THIS IS THE 13TH FIELD, PUT A CR INSTEAD OF " " ON THIS SPOT IN MEMORY
	BNE SKIPADDCR		;IF NOT SKIP OVER THIS NEXT PART
	LDA #CR				;CR IS $0D IN PETSCII
	STA VAR_PS,X
	
	LDA #" "			;RESET THE A BACK TO " " AND RESET THE Y COUNTER FOR THE NEXT ROW
	LDY #0
SKIPADDCR	
	INX
	INY
	CPX #156
	BNE INIT_VPS	
	
	;80  FOR I = 1 TO 12:P$(I,1) = "X": NEXT I
	LDA #"X"			;STORE VERITICAL POLE IN DRAW MATRIX
	STA VAR_PS1
	STA VAR_PS2
	STA VAR_PS3
	STA VAR_PS4
	STA VAR_PS5
	STA VAR_PS6
	STA VAR_PS7
	STA VAR_PS8
	STA VAR_PS9
	STA VAR_PS10
	STA VAR_PS11
	STA VAR_PS12
	
	;90  FOR I = 1 TO 7:P$(1,I) = "X": NEXT :P$(2,7) = "X"
	LDX #0
INIT_VPS1	
	STA VAR_PS,X		;STORE HORIZONTAL POLE X'S IN DRAW MATRIX
	INX
	CPX #7
	BNE INIT_VPS1
	STA VAR_PS2+6		;AND STORE THE ROPE IN THE DRAW MATRIX
	
	;95  IF C < N THEN 100
	LDA VAR_C
	CMP VAR_N
	BCC LINE100			;BRANCH IF VAR_C IS < VAR_N
	
	;97  PRINT "YOU DID ALL THE WORDS!!": STOP 
	LDA #<DIDWORDS		;PRINT THE TEXT ON SCREEN
	STA z_L
	LDA #>DIDWORDS
	STA z_H
	JSR PrintString
	JMP PROGEND
	
LINE100	
	;100 Q = INT (N *  RND (1)) + 1
	JSR RNDINIT			;FIRST WE INITIALIZE THE RND FUNCTION
	
	LDA #50				;WE WANT A NUMBER 1 TO MAX 50
	JSR RAND			;GENERATE RND UNTIL WE GET MAX 50.
	STA VAR_Q			;STORE THE RANDOM NUMBER IN VARIABLE VAR_Q
	
	;110 IF U(Q) = 1 THEN 100
	LDX VAR_Q			;LOAD THE RANDOM NUMBER IN X				
	LDA VAR_U,X			;LOAD VAR_C OFFSET X IN A. THIS IS IF THE WORD AT OFFSET X IS GUESSED ALREADY (0=NO, 1=YES)
	CMP #1
	BEQ LINE100
	
	;115 U(Q) = 1:C = C + 1: RESTORE :T1 = 0
	LDA #1
	STA VAR_U,X			;STORE IN MEM THAT WORD HAS BEEN PLAYED
	
	LDA VAR_C			;LOAD VALUE IN V_C
	CLC
	ADC #1				;INCREMENT WITH 1
	STA VAR_C			;STORE AGAIN
	;NOT SURE WHAT TO DO WITH THAT RESTORE COMMMAND...
	LDA #0				;STORE 0 IN V_T1
	STA VAR_T1
	
	;150  FOR I = 1 TO Q: READ A$: NEXT I
	LDA VAR_Q			;READ THE WORD TO LOAD
	JSR RDBASE			;READ THE DATABASE UNTIL THE WORD TO GUESS
	
	;160 L = LEN (A$): FOR I = 1 TO LEN (A$):L$(I) = MID$ (A$,I,1): NEXT I
	LDX #<VAR_AS		
	LDY #>VAR_AS
	JSR LEN				;GET THE LENGTH OF THE WORD IN V_AS
	STA VAR_L			;STORE LENGTH IN VARIABLE IN V_L 
	;WE'RE NOT ADDING THE LETTERS OF THE WORD ONE BY ONE IN L$, WE ALREADY HAVE ALL THAT IN THE V_AS VARIABLE
	
	;170  PRINT "HERE ARE THE LETTERS YOU USED:"
LINE170
	LDA #<LETTERSUSED	;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>LETTERSUSED
	STA z_H
	JSR PrintString
	
	LDA #3
	JSR WIPELINE		;WIPE LINE 6 (THE PROGRESS OF THE WORD, IN CASE IT'S A NEW WORD THATS SHORTER THEN THE NEW ONE)
	
	LDA #3
	STA CursorY			;MAKE SURE THAT THE PROGRESS OF THE WORD IS ALWAYS PRINTED ON THE 6TH LINE
	STZ CursorX			;RESET X COORDINATE OF THE CURSOR
	
	;180  FOR I = 1 TO 26: PRINT N$(I);: IF N$(I + 1) = "" THEN 200
	;190  PRINT ",";: NEXT I
	LDX #<VAR_NS		
	LDY #>VAR_NS
	STX ZPADDR			;TEMP STORE START MEM ADRES OF TEXT IN $30 AND $31
	STY ZPADDR+1
	LDY #0				;RESET Y FOR LOOPING THROUGH THE STRING
	
NSPRINTA 
	LDA (ZPADDR),Y		;LOAD A STRING CHARACTER FROM ADDRESS STORED IN POINTER ZPADDR AND ZPADDR+1 ($30 AND $31 IN THIS CASE)
	CMP #0
	BEQ NSPRINTZ		;IF EQUAL TO 0, DONE PRINTING TEXT
	JSR PrintChar		;PRINT ON SCREEN
	LDA #','
	JSR PrintChar
	INY					;NEXT LETTER
	BNE NSPRINTA		;ALWAYS JUMP, WE CAN USE BNE BECAUSE THE ZERO FLAG WILL NEVER BE SET IN INY (BECAUSE IT WONT REACH 0)
NSPRINTZ

	;200  PRINT : PRINT : FOR I = 1 TO L: PRINT D$(I);: NEXT I: PRINT : PRINT
	LDA #5
	STA CursorY			;MAKE SURE THAT THE PROGRESS OF THE WORD IS ALWAYS PRINTED ON THE 6TH LINE
	STZ CursorX			;RESET X COORDINATE OF THE CURSOR
	
	LDX #0				;START LOOP COUNTER
LOOP200
	LDA VAR_DS, X		;LOAD CHARACTER FROM V_DS OFFSET BY X
	JSR PrintChar		;PRINT THE CHARACTER ON SCREEN
	INX					;NEXT LETTER TO PRINT
	CPX VAR_L			;COMPARE LOOP COUNTER TO AMOUNT LETTERS TO BE SHOWN ON SCREEN
	BNE LOOP200			;LOOP BACK FOR NEXT LETTER TO PRINT
	
	;210  INPUT "WHAT IS YOUR GUESS";G$:R = 0
	LDA #<LGUESS		;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>LGUESS
	STA z_H
	JSR PrintString
	
	JSR LINPUT			;CAPTURE USER INPUT
	LDX #<VAR_GS		;LOAD MEM ADDRESS OF VAR_GS VAR
	LDY #>VAR_GS
	JSR CHRBUFTOVAR		;COPY CHARACTER BUFFER OVER TO VAR_GS
	
	LDA #0
	STA VAR_R			;STORE 0 IN VAR_R
	
	;220  FOR I = 1 TO 26: IF N$(I) = "" THEN 250
	LDX #0				;RESET LOOP COUNTER X
LOOP220
	LDA VAR_NS, X		;LOAD DATA FROM V_NS OFFSET X
	CMP #0				;SEE IF THE DATA LOADED IS EQUAL TO 0 
	BEQ LINE250			;IF SO, JUMP TO LINE 250
	
	;230  IF G$ = N$(I) THEN  PRINT "YOU GUESSED THAT LETTER BEFORE!": GOTO 170
	CMP VAR_GS			;COMPARE A (CURRENT CHAR FROM VAR_NS) TO VAR_GS
	BNE DONE230			;IF SO SKIP THE NEXT PART
	LDA #<LGUESSED		;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>LGUESSED
	STA z_H
	JSR PrintString
	JMP LINE170			;GOTO LINE 170
DONE230
	INX					;INCREMENT X FOR NEXT LETTER IN V_NS
	CPX	#26				;IF THIS IS THE 26TH ADDRESS LOADED THEN STOP
	BNE LOOP220			;OTHERWISE LOAD NEXT DATA FROM V_NS
	
	;240  NEXT I: PRINT "PROGRAM ERROR. RUN AGAIN.": STOP
	;WE CAN ONLY GET HERE IF THERE ARE ALREADY 26 GUESSES IN THE VAR_NS VAR, WHICH SHOULDNT BE POSSIBLE WITH A A-Z POSSIBILITIES
	;OR THERE ARE MULTIPLE LETTERS IN EACH GUESS CLOGGING UP VAR_GS. IN SHORT, IF WE GET HERE, THE PROGRAM WILL ERROR OUT, END PROGRAM!
	LDA #<PERROR		;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>PERROR
	STA z_H
	JSR PrintString
	JMP PROGEND			;END PROGRAM!

LINE250
	;250  N$(I) = G$: T1 = T1 + 1
	;AT THIS POINT X STILL CONTAINS THE LOOP COUNTER FOR THE VAR_NS FROM LINE 220
	LDA VAR_GS			;RELOAD THE LETTER THE PLAYER GUESSED
	STA VAR_NS,X		;STORE THE LETTER ON THE RIGHT MEMORY ADDRESS RESERVED FOR VAR_NS
	
	LDA VAR_T1
	CLC
	ADC #1
	STA VAR_T1			;LOAD VALUE FROM VAR_T1 (NUMBER OF TRIES), INCREASE BY 1 AND STORE AGAIN
	
	;260  FOR I = 1 TO L: IF L$(I) = G$ THEN 280
	;WE'RE USING VAR_AS FOR THE L$ IN THIS LINE SINCE IT ALREADY CONTAINS ALL THE LETTERS IN THE WORD.
	LDX #0				;RESET LOOP COUNTER
LOOP260
	LDA VAR_AS, X		;LOAD CHARACTER FROM VAR_AS OFFSET BY X
	CMP VAR_GS			;CHECK IF ITS THE SAME LETTER AS THE GUESS
	BEQ LINE280			;IF IT IS THE SAME LETTER, GOTO LINE 280
	
LINE270RET
	INX					;NEXT LETTER
	;270  NEXT I: IF R = 0 THEN 290
LINE270
	CPX VAR_L			;COMPARE LOOP COUNTER TO THE NUMBER OF LETTERS TO BE CHECKED
	BNE LOOP260			;IF NOT AT THE NUMBER OF LETTERS YET, LOOP AGAIN
	
	LDY VAR_R			;LOAD VALUE OF VAR_R IN Y
	CPY #0				;COMPARE VAR_R VALUE TO 0
	BEQ LINE290			;IF IT'S 0 GOTO LINE 290.

	;275  GOTO 300
	BNE	LINE300			;ALWAYS JUMP TO LINE 300, WE USE BNE BECAUSE THE ZERO FLAG IS NOT SET
	
LINE280	
	;280  D$(I)=G$: R=R+1: GOTO 270
	;X STILL CONTAINS THE LOOP COUNTER (I)
	LDA VAR_GS			;LOAD THE GUESSED LETTER (VAR_GS)
	STA VAR_DS, X		;STORE IN VAR_DS OFFSET BY X (I LOOP COUNTER)
	
	LDY VAR_R
	INY
	STY VAR_R			;LOAD, INCREMENT BY ONE AND STORE VAR_R AGAIN USING Y.
	BNE LINE270RET		;JUMP BACK TO THE LOOP. WE CAN USE BNE HERE, SINCE INY WILL NEVER REACH ZERO. (STY DOESNT AFFECT THE ZERO FLAG)
	
LINE290
	;290  M = M + 1: GOTO 400
	LDY VAR_M
	INY
	STY VAR_M			;INCREMENT VAR_M BY 1 USING Y AND STORE AGAIN.
	JMP LINE400			;ALWAYS GOTO LINE 400.
	
LINE300
	;300  FOR I = 1 TO L: IF D$(I) = "-" THEN 320
	LDX #0				;START LOOP COUNTER
LOOP300
	LDA VAR_DS, X		;LOAD VAR_DS LETTERS OFFSET BY X
	CMP #'-'
	BEQ LINE320			;IF THE DATA LOADED IS EQUAL TO - THEN GOTO LINE320
	;310  NEXT I: GOTO 390
	INX					;NEXT LETTER
	CPX VAR_L			;IF THE LOOP COUNTER IS AT THE LENGTH OF THE WORD
	BNE LOOP300			;IF NOT EQUAL THEN GOTO LOOP300
	
	JMP	LINE390			;OTHERWISE ALWAYS GOTO LINE 390. ALL LETTERS IN THE WORD CHECKED, ALL LETTERS GUESSED!
	
LINE320	
	;320  PRINT : FOR I = 1 TO L: PRINT D$(I);: NEXT I: PRINT : PRINT
	LDA #5
	JSR WIPELINE		;WIPE LINE 6 (THE PROGRESS OF THE WORD, IN CASE IT'S A NEW WORD THATS SHORTER THEN THE NEW ONE)
	
	LDA #5
	STA CursorY			;MAKE SURE THAT THE PROGRESS OF THE WORD IS ALWAYS PRINTED ON THE 6TH LINE
	STZ CursorX			;RESET X COORDINATE OF THE CURSOR
	
	LDX #0				;START LOOP COUNTER
LOOP320

	LDA VAR_DS, X		;LOAD VAR_DS LETTERS OFFSET BY X
	JSR PrintChar		;PRINT CHARACTER TO SCREEN.
	INX					;NEXT CHARACTER.
	CPX	VAR_L
	BNE LOOP320			;IF LOOP COUNTER IS NOT EQUAL TO V_L THEN LOOP AGAIN.
	
	;330  INPUT "WHAT IS YOUR GUESS FOR THE WORD";B$
	LDA #7
	JSR WIPELINE		;WIPE LINE 7 (ANY MESSAGE THAT A PREVIOUS GUESS WAS WRONG)
	
	LDA #<LGUESSW		;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>LGUESSW
	STA z_H
	JSR PrintString

	JSR LINPUT			;CAPTURE USER INPUT
	;WE'RE NOT GOING TO STORE IT IN V_BS, WE'LL USE THE CHARACTER BUFFER DIRECTLY FOR THIS.
	
	;340  IF A$ = B$ THEN 360
	LDX #0				;RESET LOOP COUNTER
LOOP340
	LDA VAR_AS, X		;LOAD LETTER FROM V_AS, OFFSET BY X
	STA ZPADDR			;TEMP STORE THIS VALUE IN THE ZERO PAGE
	LDA CHRBUF, X		;LOAD LETTER FROM V_BS, OFFSET BY X
	CMP ZPADDR			;COMPARE THE LETTER FROM V_BS (NOW IN A) TO V_AS, NOW IN ZPADDR
	BNE	IFELSE340		;IF IT DOESN'T MATCH THEN ITS NOT EQUAL, GOTO THE IFELSE LABEL
	
	CMP #255			;IF IT STILL MATCHES, CHECK IF THE CHARACTER IS A 255 THEN, WE HAVE TO STOP CHECKING
	BEQ IFEND340		;GO TO THE END OF THE IF
	INX
	BNE LOOP340			;NEXT LETTER AND LOOP BACK TO LOAD THE NEXT LETTER, WE CAN USE BNE HERE SINCE INX WILL NEVER ZERO OUT.

IFEND340
	;IF WE GET HERE, THE STRING MATCHES THE OTHER STRING, IF SO GOTO 360
	JMP LINE360			;NOT SURE HERE IF ANY FLAGS ARE CLEAR/SET, SINCE YOU CAN COME HERE FROM TWO BRANCH COMMANDS. SO WE JUMP HERE.

IFELSE340
	;350  PRINT "WRONG. TRY ANOTHER LETTER.": PRINT : GOTO 170
	LDA #<WRONGWORD		;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>WRONGWORD
	STA z_H
	JSR PrintString
	
	LDA #11
	JSR WIPELINE		;WIPE LINE 10 (THE GUESSED WORD)
	
	JMP	LINE170			;AND JUMP BACK TO LINE 170
	
LINE360
	;360  PRINT "RIGHT!! IT TOOK YOU ";T1;" GUESSES!"
	LDA #<RIGHTWORD1	;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>RIGHTWORD1
	STA z_H
	JSR PrintString
	
	LDA VAR_T1			;LOAD THE CONTENT OF V_T1 (NUMBER OF TRIES) IN A
	CMP #10				
	BCS HEXCASE			;IF THE NUMBER OF TRIES IS 10 OR MORE GOTO HEXCASE
	TAX					;IF ITS 9 OR LESS TRIES, TRANSFER TO X AND PRINT TO SCREEN!
	JMP NOHEXCASE

HEXCASE
	;SIMPLE CASE FOR 10 TO 26 TRIES, CAN'T BE BOTHERED WITH CREATING A HEX2DEC CONVERTER
	CMP #10
	BEQ HEXCASE10
	CMP #11
	BEQ HEXCASE11
	CMP #12
	BEQ HEXCASE12
	CMP #13
	BEQ HEXCASE13
	CMP #14
	BEQ HEXCASE14
	CMP #15
	BEQ HEXCASE15
	CMP #16
	BEQ HEXCASE16
	CMP #17
	BEQ HEXCASE17
	CMP #18
	BEQ HEXCASE18
	CMP #19
	BEQ HEXCASE19
	CMP #20
	BEQ HEXCASE20
	CMP #21
	BEQ HEXCASE21
	CMP #22
	BEQ HEXCASE22
	CMP #23
	BEQ HEXCASE23
	CMP #24
	BEQ HEXCASE24
	CMP #25
	BEQ HEXCASE25
	CMP #26
	BEQ HEXCASE26
	
HEXCASE10
	LDX #$10 
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE11
	LDX #$11
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE12
	LDX #$12
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE13
	LDX #$13
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE14
	LDX #$14
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE15
	LDX #$15
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE16
	LDX #$16
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE17
	LDX #$17
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE18
	LDX #$18
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE19
	LDX #$19
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE20
	LDX #$20
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE21
	LDX #$21
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE22
	LDX #$22
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE23
	LDX #$23
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE24
	LDX #$24
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE25
	LDX #$25
	BNE NOHEXCASE				;ALWAYS BRANCH, BECAUSE ZERO FLAG WONT BE SET IN THE IMMEDIATE LDX COMMAND
HEXCASE26
	LDX #$26

NOHEXCASE
	STX MONHEX+1		;STORE IN MONHEX +1
	JSR HEXTOASC		;CONVERT THIS VALUE TO ASCII (WILL END UP IN $DE AND $DF)
	LDA MONHEX+4		;PRINT TRIES ON SCREEN (LOW NIBBLE)
	JSR PrintChar
	LDA MONHEX+5		;PRINT TRIES ON SCREEN (HIGHT NIBBLE)
	JSR PrintChar
	
	LDA VAR_T1			;PRINT TRIES ON SCREEN
	JSR PrintChar
	
	LDA #<RIGHTWORD2	;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>RIGHTWORD2
	STA z_H
	JSR PrintString
	
	LDA #10
	JSR WIPELINE		;WIPE LINE 11 (WHAT IS YOUR GUESS FOR THE WORD)
	
LINE370
	;370  INPUT "WANT ANOTHER WORD?";W$: IF W$ = "YES" THEN 50
	LDA #<ANOTHERWORD	;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>ANOTHERWORD
	STA z_H
	JSR PrintString
	JSR LINPUT			;CAPTURE USER INPUT
	
	LDA #3
	JSR WIPELINE		;WIPE LINE 4 (GUESSED LETTERS)
	LDA #7
	JSR WIPELINE		;WIPE LINE 8 (MESSAGES SUCH AS THAT THE PLAYER IS HUNG)
	LDA #9
	JSR WIPELINE		;WIPE LINE 10 (SORRY, YOU LOSE. THE WORD WAS:)
	LDA #11
	JSR WIPELINE		;WIPE LINE 12 (WANT ANOTHER WORD Y/N?)
	
	LDA #13
	JSR WIPELINE		;WIPE LINE 14 - 25 (THE HANGMAN DRAWING)
	LDA #14
	JSR WIPELINE
	LDA #15
	JSR WIPELINE
	LDA #16
	JSR WIPELINE
	LDA #17
	JSR WIPELINE
	LDA #18
	JSR WIPELINE
	LDA #19
	JSR WIPELINE
	LDA #20
	JSR WIPELINE
	LDA #21
	JSR WIPELINE
	LDA #22
	JSR WIPELINE
	LDA #23
	JSR WIPELINE
	LDA #24
	JSR WIPELINE
	
	LDA CHRBUF			;LOAD THE FIRST LETTER OF THE CHARACTER BUFFER
	CMP #$59			;IF IT'S A Y FROM YES, THEN GOTO LINE 50 ($59 IS A Y KEY)
	BEQ JUMPTO50

	JMP LINE380			;WE CANT BE CERTAIN OF FLAGS HERE, SO WE JMP INSTEAD OF BRANCH
	
JUMPTO50
	JMP LINE50

LINE380
	;380  PRINT : PRINT "IT'S BEEN FUN! BYE FOR NOW.": GOTO 999
	LDA #<BYE1			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>BYE1
	STA z_H
	JSR PrintString
	JMP PROGEND			;AND EXIT PROGRAM

LINE390
	;390  PRINT "YOU FOUND THE WORD!": GOTO 370
	LDA #<FOUNDWORD			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>FOUNDWORD
	STA z_H
	JSR PrintString
	JMP LINE370
	
LINE400
	;400  PRINT : PRINT "SORRY, THAT LETTER ISN'T IN THE WORD."
	LDA #<WRONGLET		;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>WRONGLET
	STA z_H
	JSR PrintString
	
	;410  ON M GOTO 415,420,425,430,435,440,445,450,455,460
	;415  PRINT "FIRST WE DRAW A HEAD": GOTO 470
	;420  PRINT "NOW WE DRAW A BODY.": GOTO 470
	;425  PRINT "NEXT WE DRAW AN ARM.": GOTO 470
	;430  PRINT "THIS TIME IT'S THE OTHER ARM.": GOTO 470
	;435  PRINT "NOW, LET'S DRAW THE RIGHT LEG.": GOTO 470
	;440  PRINT "THIS TIME WE DRAW THE LEFT LEG.": GOTO 470
	;445  PRINT "NOW WE PUT UP A HAND.": GOTO 470
	;450  PRINT "NEXT THE OTHER HAND.": GOTO 470
	;455  PRINT "NOW WE DRAW ONE FOOT": GOTO 470
	;460  PRINT "HERE'S THE OTHER FOOT -- YOU'RE HUNG!!"
	LDA VAR_M				;LOAD V_M INTO A
	CMP #1				;COMPARE IT TO 1
	BEQ CASE4001		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #2				;COMPARE IT TO 2
	BEQ CASE4002		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #3				;COMPARE IT TO 3
	BEQ CASE4003		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #4				;COMPARE IT TO 4
	BEQ CASE4004		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #5				;COMPARE IT TO 5
	BEQ CASE4005		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #6				;COMPARE IT TO 6
	BEQ CASE4006		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #7				;COMPARE IT TO 7
	BEQ CASE4007		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUTz_
	CMP #8				;COMPARE IT TO 8
	BEQ CASE4008		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #9				;COMPARE IT TO 9
	BEQ CASE4009		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #10				;COMPARE IT TO 10
	BEQ CASE40010		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	;NO ESCAPE NEEDED AFTER THIS, V_M HAS TO BE BETWEEN 1 AND 10.
CASE4001
	LDA #<HANG1			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG1
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4002
	LDA #<HANG2			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG2
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4003
	LDA #<HANG3			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG3
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4004
	LDA #<HANG4			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG4
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4005
	LDA #<HANG5			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG5
	STA z_H
	JSR PrintString
	BVC LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4006
	LDA #<HANG6			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG6
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4007
	LDA #<HANG7			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG7
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4008
	LDA #<HANG8			;PRINT TEXT ON SCREEN
	STA z_L
	LDA #>HANG8
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE4009
	LDA #<HANG9			;PRINT TEXT ON SCREEN
	STA z_L
	LDA	#>HANG9
	STA z_H
	JSR PrintString
	JMP LINE470			;GOTO LINE 470, WE CANT BE CERTAIN OF FLAGS, SO WE USE JMP INSTEAD OF BRANCH
CASE40010
	LDA #<HANG10		;PRINT TEXT ON SCREEN
	STA z_L
	LDA	#>HANG10
	STA z_H
	JSR PrintString
	;NO NEED TO JUMP TO 470 HERE, AS THE NEXT COMMAND IS LINE 470 ALREADY :)

LINE470
	;470  ON M GOTO 480,490,500,510,520,530,540,550,560,570
	;480 P$(3,6) = "-":P$(3,7) = "-":P$(3,8) = "-":P$(4,5) = "(":P$(4,6) = "."
	;481 P$(4,8) = ".":P$(4,9) = ")":P$(5,6) = "-":P$(5,7) = "-":P$(5,8) = "-": GOTO 580
	;490  FOR I = 6 TO 9:P$(I,7) = "X": NEXT I: GOTO 580
	;500  FOR I = 4 TO 7:P$(I,I - 1) = "\": NEXT I: GOTO 580
	;510 P$(4,11) = "/":P$(5,10) = "/": P$(6,9) = "/": P$(7,8) = "/": GOTO 580
	;520 P$(10,6) = "/":P$(11,5) = "/": GOTO 580
	;530 P$(10,8) = "\":P$(11,9) = "\": GOTO 580
	;540 P$(3,11) = "\": GOTO 580
	;550 P$(3,3) = "/": GOTO 580
	;560 P$(12,10) = "\":P$(12,11) = "-": GOTO 580
	;570 P$(12,3) = "-":P$(12,4) = "/"
	LDA VAR_M				;LOAD V_M INTO A
	CMP #1				;COMPARE IT TO 1
	BEQ CASE4701		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #2				;COMPARE IT TO 2
	BEQ CASE4702		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #3				;COMPARE IT TO 3
	BEQ CASE4703		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #4				;COMPARE IT TO 4
	BEQ CASE4704		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #5				;COMPARE IT TO 5
	BEQ CASE4705		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #6				;COMPARE IT TO 6
	BEQ CASE4706J		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #7				;COMPARE IT TO 7
	BEQ CASE4707J		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #8				;COMPARE IT TO 8
	BEQ CASE4708J		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #9				;COMPARE IT TO 9
	BEQ CASE4709J		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT
	CMP #10				;COMPARE IT TO 10
	BEQ CASE47010J		;IF IT IS, JUMP TO THE (SELECT) CASE OUTPUT

CASE4706J				;THESE FIVE LABELS WITH JUMPS ARE INTERMEDIARY. THE BEQ CASES ABOVE CAN'T
	JMP CASE4706		;REACH THE CASE LABELS OTHERWISE, THEY ARE 128+ BYTES AWAY.
CASE4707J				
	JMP CASE4707
CASE4708J				
	JMP CASE4708		
CASE4709J
	JMP CASE4709
CASE47010J
	JMP CASE47010	

CASE4701
	;480 P$(3,6) = "-":P$(3,7) = "-":P$(3,8) = "-":P$(4,5) = "(":P$(4,6) = "."
	;481 P$(4,8) = ".":P$(4,9) = ")":P$(5,6) = "-":P$(5,7) = "-":P$(5,8) = "-": GOTO 580
	LDA #'-'
	STA VAR_PS3+5
	STA VAR_PS3+6
	STA VAR_PS3+7
	STA VAR_PS5+5
	STA VAR_PS5+6
	STA VAR_PS5+7
	LDA #'('
	STA VAR_PS4+4
	LDA #'.'
	STA VAR_PS4+5		
	STA VAR_PS4+7
	LDA #')'
	STA VAR_PS4+8
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4702
	;490  FOR I = 6 TO 9:P$(I,7) = "X": NEXT I: GOTO 580
	LDA #'X'
	STA VAR_PS6+6
	STA VAR_PS7+6
	STA VAR_PS8+6
	STA VAR_PS9+6
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4703
	;500  FOR I = 4 TO 7:P$(I,I - 1) = "\": NEXT I: GOTO 580
	LDA #'\'
	STA VAR_PS4+2
	STA VAR_PS5+3
	STA VAR_PS6+4
	STA VAR_PS7+5
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4704
	;510 P$(4,11) = "/":P$(5,10) = "/": P$(6,9) = "/": P$(7,8) = "/": GOTO 580
	LDA #'/'
	STA VAR_PS4+10
	STA VAR_PS5+9
	STA VAR_PS6+8
	STA VAR_PS7+7
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4705
	;520 P$(10,6) = "/":P$(11,5) = "/": GOTO 580
	LDA #'/'
	STA VAR_PS10+5
	STA VAR_PS11+4
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4706	
	;530 P$(10,8) = "\":P$(11,9) = "\": GOTO 580
	LDA #'\'
	STA VAR_PS10+7
	STA VAR_PS11+8
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4707
	;540 P$(3,11) = "\": GOTO 580
	LDA #'\'
	STA VAR_PS3+10
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4708
	;550 P$(3,3) = "/": GOTO 580
	LDA #'/'
	STA VAR_PS3+2
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE4709
	;560 P$(12,10) = "\":P$(12,11) = "-": GOTO 580
	LDA #'\'
	STA VAR_PS12+9
	LDA #'-'
	STA VAR_PS12+10
	BNE LINE580				;ALWAYS BRANCH. WE USE BNE BECAUSE ZERO FLAG IS NOT SET IN PREVIOUS LDA COMMAND.
CASE47010
	;570 P$(12,3) = "-":P$(12,4) = "/"
	LDA #'-'
	STA VAR_PS12+2
	LDA #'/'
	STA VAR_PS12+3
	
LINE580	
	;580  FOR I = 1 TO 12: FOR J = 1 TO 12: PRINT P$(I,J);: NEXT J
	;590  PRINT : NEXT I: PRINT : PRINT : IF M <  > 10 THEN 170
	LDA #13
	STA CursorY			;MAKE SURE THAT THE PROGRESS OF THE WORD IS ALWAYS PRINTED ON THE 6TH LINE
	STZ CursorX			;RESET X COORDINATE OF THE CURSOR
	
	LDA #<VAR_PS			
	STA z_L
	LDA #>VAR_PS
	STA z_H
	JSR PrintString		;PRINT THE HANGMAN PICTURE TO SCREEN	
	
	LDA VAR_M
	CMP #10				;CHECK IF V_M IS EQUAL TO 10.
	BNE LINE590GOTO		;IF NOT, HOP OVER TO LINE590GOTO LABEL, IT WILL JUMP TO LINE 170. SINCE ITS TO FAR AWAY TO BNE TO DIRECTLY
	BEQ LINE600			;IF IT IS 10. HOP OVER TO LINE 600 (SKIP GOTO 170 IN THE NEXT LINE), WE USE BEQ BECAUSE ZERO FLAG IS SET IN PREVIOUS CMP COMMAND
	
LINE590GOTO
	JMP	LINE170			;JUMP BACK TO LINE 170, WE USE JMP SINCE DESTINATION IS TOO FAR AWAY FOR A BRANCH COMMAND
	
LINE600
	;600  PRINT "SORRY, YOU LOSE. THE WORD WAS ";A$	
	LDA #<LOSE			
	STA z_L
	LDA #>LOSE
	STA z_H
	JSR PrintString		;PRINT YOU LOSE
	
	LDA #10
	JSR WIPELINE		;WIPE LINE 11 (WHAT IS YOUR GUESS) ; THE WORD PRINTED NEXT MIGHT NOT BE LONG ENOUGH TO COVER OVER THIS.
	LDA #10
	STA CursorY			;WIPING THE LINE MESSED WITH THE CURSOR Y, SO MAKE SURE THE WORD IS PRINTED 
	STZ CursorX			;RESET X COORDINATE OF THE CURSOR
	
	LDA #<VAR_AS			
	STA z_L
	LDA #>VAR_AS		
	STA z_H
	JSR PrintString		;PRINT THE WORD

	;610  PRINT "YOU MISSED THAT ONE. DO YOU ";: GOTO 370
	LDA #<DOYOUWANT			
	STA z_L
	LDA #>DOYOUWANT
	STA z_H
	JSR PrintString		;PRINT TEXT
	JMP LINE370			;JUMP TO LINE 370, BECAUSE THE DESTINATION IS TOO FAR AWAY FOR A BRANCH COMMAND
	
	;end of program
PROGEND	
	JMP *				;GO INTO INFINITE LOOP ON THIS LINE (AKA PAUSE PROGRAM)

	include "\SrcAll\BasicFunctions-modMarc.asm"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
SetVeraHML:		;Select Memory address %----AAAA YYYYYYYYY XXXXXXXX
				;Set Inc to            %AAAA----
						
		sta V_H	
		sty V_M
		stx V_L
	rts


AddVHML_YX		;add 24 bit %00000000 YYYYYYYYY XXXXXXXX to V_HML
		lda #0
AddVHML_AYX		;add 24 bit %AAAAAAAA YYYYYYYYY XXXXXXXX to V_HML
		pha
			clc
			txa
			adc V_L
			sta V_L
			tya
			adc V_M
			sta V_M
		pla
		adc V_H
		sta V_H
		rts	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
PrintChar:
	sec						;Set carry flag
	sbc #32					;Our charactrer has no space, so subtract the character in the accumulator with 32.
	sta z_as				;store the character in accumulator in the z_as backup address.
	
	phx						;Backup the registers we use (65c02 opcode), push X to stack
	phy						
	lda z_h					
	pha						
	lda z_l					
	pha						
		lda z_as			;RELOAD A REGISTER FROM BACKUP THAT WAS JUST MADE.
		
		stz z_H				
		asl
		rol	z_H
		asl 
		rol	z_H
		asl 
		rol	z_H				;MULTIPLY A BY 8 AND STORE ANY CARRY TO Z_H
		
		adc #<BitmapFont	;Add the address of our font TO A
		sta z_L
		lda z_H
		adc #>BitmapFont
		sta z_H	
	
		stz z_d				;For the 24 bits we'll use z_d  z_e and A
			
		lda CursorY	 ;CursorY* 320*8 = Cursor Y * %00000000 00001010 00000000
		asl					;320 bytes per line 8 lines per char
		rol z_d
		sta z_e				;Shift one bit left and store
		
		asl
		rol z_d
		asl
		rol z_d				;Shift 2 bits left
		
		clc
		adc z_e				;Add carry to M byte
		tay
		
		lda z_d				
		adc #0				;Add carry to H byte
		sta z_d
		
		stz z_e
		lda CursorX	;CursorX* 8 = Cursor X * %00000000 00000000 00001000
		
		asl
		rol z_e
		asl
		rol z_e
		asl
		rol z_e				;Shift 3 bits left
		
		tax					;X contains L byte 
		
		tya 				;Add carry to M byte
		adc z_e				
		tay					;Y contains M byte
		
		lda z_d				;Add carry to H byte & set AutoInc
		adc #$10			;A contains H byte  
		
		jsr SetVeraHML		;Set Screen Address
		
		
		ldy #0						;Line in Font Char
CharLineAgain:
		phy
			lda (z_hl),y
			sta z_as
			ldx #8				;8 Bytes (pixels) Per Line
CharPixelAgain:				
			lda #0
			rol z_as			;Pop a bit off our font byte
			rol
			sta V_D1			;Send to screen ram
			
			dex 
			bne CharPixelAgain	;Next Pixel
			
			ldy #>(320-8)
			ldx #<(320-8)
			jsr AddVHML_YX			;Move down screen line (320 byte)
		ply
		iny							;Move down a line in our font
		tya
		cmp #8
		bne CharLineAgain			;8 lines per character
		
		inc CursorX
		lda CursorX
		cmp #40						;40 Characters per screen line
		bne NoNewLine
		jsr NewLine
NoNewLine:	
	pla								;Restore the registers
	sta z_l
	pla
	sta z_h	
	ply
	plx
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		
CursorX: db 0				;starting position of cursor X = 0
CursorY: db 0				;starting position of cursor Y = 0

NewLine:		
	stz CursorX				;Zero X
	inc CursorY				;Increase Y
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;---------------------------------------------
;FUNCTION - BLINK CURSOR (BLINKS A _ CHARACTER EVERY SECOND ON/OFF)
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC BLINKCURZ		;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
BLINKCUR
	JSR CLOCKAPI		;CALL THE COMMANDER X16 CLOCK API, THE RESULTS WILL BE PLACED IN ZP
	LDA	VAR_SEC			;LOAD THE AMOUNT OF SECONDS PREVIOUSLY STORED
	CMP CLOCKSEC		;COMPARE TO THE AMOUNT OF SECONDS CURRENTLY IN THE CLOCK (RESULT FROM THE CLOCKAPI CALL)
	BEQ BLINKCURY		;IF ITS THE SAME AMOUNT OF SECONDS, THEN NOTHING NEEDS TO CHANGE, JUMP TO END OF SUBROUTINE
						;OTHERWISE THE SECONDS ARE DIFFERENT, WE NEED TO CHANGE THE BLINKING CURSOR
	LDA VAR_BLINK		;LOAD THE CURRENT VALUE OF THE BLINKING CURSOR (0=OFF/1=ON)
	CMP #0
	BEQ BLINKCURA		;IF THE CURSOR IS CURRENTLY OFF, JUMP TO TURN IT ON
	LDA #0
	STA VAR_BLINK		;STORE THE VALUE 0 TO THE BLINKING CURSOR (OFF)
	BEQ BLINKCURB		;JUMP TO BLINKCURB, WE USE BEQ BECAUSE ZERO FLAG WILL BE SET IN LDA COMMAND
	
BLINKCURA
	LDA #1
	STA VAR_BLINK		;STORE THE VALUE 1 TO THE BLINKING CURSOR (ON)

BLINKCURB				;HERE WE NEED TO ACTUALLY PRINT A CURSOR (OR NOT) AT THE LOCATION OF THE CURSOR X
	LDA CLOCKSEC
	STA VAR_SEC			;STORE THE CURRENT AMOUNT OF SECONDS IN VAR_SEC, FOR THE NEXT TIME WE CHECK THE BLINKING CURSOR SUB
	
	LDA VAR_BLINK		;LOAD THE VALUE OF THE BLINKER IN A
	CMP #0				;IF IT'S A 0 THEN PRINT A SPACE AT THE LOCATION OF THE CURSOR
	BEQ BLINKCURC
	
	LDA #'.'
	JSR PrintChar		;OTHERWISE PRINT A _ IN THE LOCATION OF THE CURSOR
	JMP BLINKCURD
	
BLINKCURC
	LDA #' '
	JSR PrintChar		;OTHERWISE PRINT SPACE IN THE LOCATION OF THE CURSOR
	
BLINKCURD
	LDA CursorX	
	SEC					;ADD CARRY, OR THE SUBTRACT WILL NOT SUBTRACT 1 BUT 2 FROM CURSOR X
	SBC #1
	STA CursorX			;SUBTRACT 1 FROM THE CURSOR X LOCATION AND SAVE IT AGAIN. SO THE USER INPUT WIL OVERWRITE THE _ CHARCTER ON SCREEN.
	
BLINKCURY
	RTS					;RETURN TO PREVIOUS CODE
BLINKCURZ

;---------------------------------------------
;FUNCTION - READ KEYBOARD BUFFER UNTIL ENTER KEY IS PRESSED (30 CHARACHTERS MAX)
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC LINPUTZ			;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
LINPUT
	LDX #0				;RESET THE X COUNTER, KEEP TRACK OF NUMBER OF LETTERS ENTERED
	STX CHRBUFC
LINPUTA
	
	JSR BLINKCUR		;BLINK THE CURSOR WHILE WE WAIT FOR USER INPUT
	JSR GETIN			;READ KEYBOARD USING A KERNAL CALL; BE AWARE! THIS WILL RESET X
	CMP #$0				;IF NO KEY HAS BEEN PRESSED.
	
	BEQ LINPUTA			;LOOP BACK TO CHECK KEYBOARD IF NO KEY HAS BEEN PRESSED
	LDX CHRBUFC			;RELOAD X FROM BACKUP IN CHRBUFC AS X WAS RESET BY JSR GETIN
	;HIJACK THE INPUT TO DO SOME RND SEED REGENERATION
	PHA					;COPY THE KEY IN THE STACK FOR NOW
		CLC
		ADC SEED		;ADD THE OLD SEED TO THE KEY
		STA SEED		;STORE NEW SEED
	PLA 				;RELOAD THE KEY PRESSED IN A FROM STACK 
	;RND REGENERATION DONE!
	
	CMP #KENTER			;CHECK IF ENTER KEY IS ENTERED AS KEY, IF SO FINISH BY ADDING $FF AND LEAVE FUNCTION
	BEQ LINPUTB
	
	STA CHRBUF,X		;IF ANYTHING ELSE THEN ENTER KEY. STORE KEY IN MEMORY BUFFER, OFFSET BY X VALUE
	INX					;INCREMENT NUMBER OF STORED CHARACTERS X
	STX CHRBUFC			;STORE X (NUMBER OF CHARACTERS ENTERED) IN CHRBUFC, AS X WILL GET RESET THE NEXT TIME JSR GETIN IS CALLED.
	CPX #30				;CHECK IF THIS WAS CHARACTER NUMBER 30, THEN WE FINISH AS WELL (RETURN KEY)
	BEQ LINPUTB
	JSR PrintChar		;OTHERWISE PRINT KEY ON SCREEN AND RETURN TO LOOP TO CAPTURE ANOTHER KEY
	JMP LINPUTA			;ALWAYS JUMP
LINPUTB
	LDA #255			;FINISH OFF THE CHARACTER BUFFER BY ADDING $FF BEHIND THE LAST LETTER IN MEMORY
	STA CHRBUF,X
	STX CHRBUFC			;AND STORE NUMBER OF CHARACHTERS IN LAST BYTE
	
LINPUTY					;SUBROUTINE TERMINATOR (GO BACK WHERE YOU CAME FROM BEFORE!)
	RTS
LINPUTZ					;JUST SKIPPING OVER FUNCTION, NO RTS OTHERWISE BACK TO PROMPT!

;---------------------------------------------
;FUNCTION - COPY CHARACTER BUFFER TO VAR (X AND Y WILL CONTAIN DESTINATION MEMORY ADDRESS)
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	JMP CHRBUFTOVARZ	;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
CHRBUFTOVAR
	STX ZPADDR			;TEMP STORE START MEM ADRES OF TEXT IN $30 AND $31
	STY ZPADDR+1
	LDY #0				;RESET Y FOR LOOPING THROUGH THE STRING
CHRBUFTOVARA
	LDA CHRBUF,Y		;LOAD CHAR FROM BUFFER
	STA (ZPADDR),Y		;STORE CHAR IN VARIABLE
	CMP #255
	BEQ CHRBUFTOVARY	;COMPARE THE CHAR TO 255, IF IT IS, END SUBROUTINE
	INY					;IF NOT 255 THEN INCREMENT Y
	BNE CHRBUFTOVARA	;AND TRANSFER NEXT CHAR (USING BNE BECAUSE THE ZERO FLAG WILL NEVER BE SET IN INY)
CHRBUFTOVARY			;SUBROUTINE TERMINATOR (GO BACK WHERE YOU CAME FROM BEFORE!
	RTS
CHRBUFTOVARZ			;JUST SKIPPING OVER FUNCTION, NO RTS OTHERWISE BACK TO PROMPT!

;---------------------------------------------
;FUNCTION - CLEAR MEMORY STARTING AT MEMORY ADDRESS X AND Y AND KEEP GOING FOR NUMBER OF BYTES IN A
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC CLRMEMZ			;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
CLRMEM
	STX ZPADDR			;TEMP STORE START MEM ADRES OF TEXT IN $30 AND $31
	STY ZPADDR+1
	STA ZPADDR+2		;STORE AMOUNT OF BYTES TO CLEAR IN $02
	LDY #0				;RESET Y FOR LOOPING THROUGH THE STRING
	LDA #0				;FILL A WITH 0
	
CLRMEMA
	STA (ZPADDR),Y		;EMPTY (00) MEMORY AT THE MEMORY ADRESS STORED IN ZPADDR, PLUS OFFSET Y
	INY					;SHIFT TO NEXT BYTE 
	CPY ZPADDR+2		;IF THE AMOUNT OF BYTES CLEARED IS THE SAME AS WE NEEDED TO DO, EXIT FUNCTION
	BEQ CLRMEMY			
	
	CLV					
	BVC CLRMEMA			;OTHERWISE LOOP AGAIN
CLRMEMY					;SUBROUTINE TERMINATOR (GO BACK WHERE YOU CAME FROM BEFORE!)
	RTS
CLRMEMZ					;JUST SKIPPING OVER FUNCTION, NO RTS OTHERWISE BACK TO PROMPT!

;---------------------------------------------
;FUNCTION - WIPE A LINE OF TEXT (FILL WITH SPACEBARS), LINE NUMBER SUPPLIED IN A
;---------------------------------------------
	CLV					;CLEAR OVERFLOW FLAG
	BVC WIPELINEZ		;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
WIPELINE
	STA CursorY			;CHANGE CURSOR Y
	STZ CursorX			;RESET CURSOR X

	;NOW WIPE THE WHOLE LINE WITH BLANK SPACES
	LDA #" "
	LDX #0
WIPELINEA
	JSR PrintChar		;PRINT SPACEBAR
	INX
	CPX #40				;CHECK IF 40 CHARACTERS HAVE BEEN PRINTED ON THE LINE ALREADY
	BEQ WIPELINEY
	BNE WIPELINEA		;OTHERWISE PRINT AGAIN, WE BRANCH USING BNE BECAUSE ZERO FLAG WILL NOT BE SET IN LAST CPX COMMAND
WIPELINEY				;DONE WIPING THE LINE
	RTS
WIPELINEZ

;---------------------------------------------
;FUNCTION - RANDOM NUMBER GENERATOR, SETS THE RND SEED TO A NUMBER OF 1 TO MAX IN ACCUMULATOR
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC RANDZ			;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
RAND
	CLC					;CLEAR THE CARRY BEFORE ADD COMMAND BELOW
	ADC #1				;ADD 1 TO THE VALUE ACCUMULATOR (WE NEEDED THE CLC FOR THIS)
	STA $04				;TEMP STORE MAX NUMBER WE WANT TO GENERATE IN $04
	LDX #1				;START A COUNTER ON REGISTER X

RANDA
	JSR RERND 			;GENERATE A RANDOM NUMBER	
	LDA SEED			;LOAD THE NEW RANDOM NUMBER (WAS DUMPED IN VARIABLE SEED)
	CMP $04				;COMPARE IT TO THE NUMBER WE WANTED TO BE BELOW THE MAX MUMBER IN $04
	BCC RANDY			;IF ALREADY BELOW THE NUMBER WE WANTED, DONE!
	
	JMP RANDA			;JUMP BACK TO RE-GENERATE NUMBER AND CHECK AGAIN, WE JUMP INSTEAD OF BRANCH BECAUSE WE'RE UNCERTAIN ABOUT THE FLAGS
RANDY
	RTS
RANDZ

;---------------------------------------------
;FUNCTION - NUMBER RE-RANDOMIZER
;---------------------------------------------
	CLV 				;CLEAR OVERFLOW FLAG
	BVC RERNDZ			;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
RERND
	;SIMPLE 8-BIT SEED RE-RANDOMIZER (ACTUALLY A LINEAR FEEDBACK SHIFT REGISTER)
	;(FROM HERE: http://www.randomterrain.com/atari-2600-lets-make-a-game-spiceware-10.html)
	LDA SEED			;LOAD THE SEED INTO ACCUMULATOR
    LSR					;SHIFT ALL BITS TO THE LEFT (MULTIPLY EVERYTHING BY TWO)
    BCC NOEOR			;IF CARRY (FROM LSR) IS CLEAR SKIP THE EOR
    EOR #$B4 			;DO A EOR WITH VALUE $B4
NOEOR	
	STA SEED			;RESTORE THE SEED, NUMBER IS NOW REGENERATED
RERNDY
	RTS
RERNDZ

;---------------------------------------------
;FUNCTION - RANDOM NUMBER GENERATOR INITIALIZER
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC RNDINITZ		;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
RNDINIT
	LDA SEED			;LOAD SEED MEM ADDRESS, IF IT DOESN'T CONTAIN 0, SKIP TO RNDINITA
	CMP #0
	BNE	RNDINITA		
	;THEN WE NEED TO ASK THE USER TO ENTER THE DATE
	LDA #<ASKNUM		;PRINT ASK FOR THE DATE
	sta z_L
	LDA #>ASKNUM
	sta z_H
	JSR PrintString
	
	JSR LINPUT			;NOW LETS GET SOME USER INPUT, ONLY USED TO RE-RANDOMIZE USING KEY VALUES.
	
	JMP RNDINITY		;WE JUMP TO RNDINITY INSTEAD OF BRANCH, SINCE WE'RE UNSURE OF THE FLAGS SET IN LINE INPUT SUBROUTINE
RNDINITA				
	JSR RERND			;RE-GENERATE RND
RNDINITY
	
	RTS
RNDINITZ

;---------------------------------------------
;FUNCTION - HEX TO ASCII (SO WE CAN PRINT A HEX VALUE ON SCREEN), 	$BA TO $BC (MSN) AND $BD (LSN)
;																	$BB TO $BE (MSN) AND $BF (LSN)
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC HEXTOASCZ		;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
HEXTOASC
	LDA $DA				;LOAD VALUE TO BE PRINTED IN ACCUMULATOR
;HEX to ASCII (taken from : http://atariage.com/forums/blog/563/entry-11678-hex-to-ascii-string/)
;  A = entry value
	SED        ;2  @2
	TAX        ;2  @4
	AND #$0F   ;2  @6
	CMP #9+1   ;2  @8
	ADC #$30   ;2  @10
	TAY        ;2  @12
	TXA        ;2  @14
	LSR        ;2  @16
	LSR        ;2  @18
	LSR       ;2  @20
	LSR        ;2  @22
	CMP #9+1   ;2  @24
	ADC #$30   ;2  @26
	CLD        ;2  @28
;  A = MSN ASCII char (MOST SIGNIFICANT NIBBLE)
;  Y = LSN ASCII char (LEAST SIGNIFICANT NIBBLE)
	STA $DC	;STORE A IN MONHEX ($DB) + 1 = $DC
	STY $DD	;STORE Y IN MONHEX ($DB) + 2 = $DD
	
	LDA $DB			;LOAD VALUE TO BE PRINTED IN ACCUMULATOR
;HEX to ASCII (taken from : http://atariage.com/forums/blog/563/entry-11678-hex-to-ascii-string/)
;  A = entry value
	SED        ;2  @2
	TAX        ;2  @4
	AND #$0F   ;2  @6
	CMP #9+1   ;2  @8
	ADC #$30   ;2  @10
	TAY        ;2  @12
	TXA        ;2  @14
	LSR        ;2  @16
	LSR        ;2  @18
	LSR       ;2  @20
	LSR        ;2  @22
	CMP #9+1   ;2  @24
	ADC #$30   ;2  @26
	CLD        ;2  @28
;  A = MSN ASCII CHAR (MOST SIGNIFICANT NIBBLE)
;  Y = LSN ASCII CHAR (LEAST SIGNIFICANT NIBBLE)
	STA $DE	;STORE A IN MONHEX ($DE)
	STY $DF	;STORE Y IN MONHEX ($DF)
HEXTOASCY
	RTS
HEXTOASCZ

;---------------------------------------------
;FUNCTION - READ DATABASE OF WORDS, (SIMULATE BASIC'S READ COMMAND) STORE EACH WORD IN V_AS. REGISTER A STORES THE WORD TO LOAD (THE NUMBER)
; ZPADDR AND ZPADDR+1 WILL BE USED TO CONTAIN THE STARTING MEMORY ADDRESS OF THE DATABASE (DATABASE1 THROUGH DATABASE 5)
; ZPADDR+2 WILL CONTAIN THE NUMBER OF WORDS TO READ (SUBTRACTED BY MULTIPLES OF TEN AS NEEDED FOR THE VARIOUS DATABASES)
; ZPADDR+3 WILL CONTAIN Y TEMPORARILY WHILE WE STORE THE LETTER IN THE V_AS VARIABLE
; ZPADDR+4 WILL CONTAIN THE NUMBER OF LETTERS FROM PREVIOUS WORDS, TO SUBTRACT FROM Y FOR PROPERLY FILLING THE V_AS VARIABLE
; ZPADDR+5 WILL CONTAIN A TEMPORARILY WHILE WE DO SOME Y SUBTRACTIONS
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	JMP RDBASEZ			;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
RDBASE
	;FIRST WE HAVE TO FIND OUT, WHICH OF THE 5 DATABASES TO LOAD, 10 WORDS PER DATABASE
	STA	ZPADDR+2		;TEMP STORE THE NUMBER OF WORDS TO READ IN #02
	
	CMP #11				;IF WE'RE LOOKING FOR WORD 1 TO 10 LOAD DATABASE 1
	BCC	RDBASE1
	SEC					;CLEAR THE CARRY FLAG
	SBC #10				;SUBTRACT 10
	
	CMP #11				;IF WE'RE LOOKING FOR WORD 1 TO 10 LOAD DATABASE 2
	BCC	RDBASE2
	SEC					;CLEAR THE CARRY FLAG
	SBC #10				;SUBTRACT 10
	
	CMP #11				;IF WE'RE LOOKING FOR WORD 1 TO 10 LOAD DATABASE 3
	BCC	RDBASE3
	SEC					;CLEAR THE CARRY FLAG
	SBC #10				;SUBTRACT 10
	
	CMP #11				;IF WE'RE LOOKING FOR WORD 1 TO 10 LOAD DATABASE 4
	BCC	RDBASE4
	SEC					;CLEAR THE CARRY FLAG
	SBC #10				;SUBTRACT 10
	
	CMP #11				;IF WE'RE LOOKING FOR WORD 1 TO 10 LOAD DATABASE 5
	BCC	RDBASE5
	
RDBASE1
	LDX #<DATABASE1		;LOAD THE ADRESS OF DATABASE 1 IN X AND Y, AND GOTO RDBASEA TO START LOADING LETTERS
	LDY #>DATABASE1
	JMP RDBASEA			;JUMP TO RDBASEA INSTEAD OF BRANCH BECAUSE WE'RE UNSURE OF FLAGS.
RDBASE2
	LDX #<DATABASE2		;LOAD THE ADRESS OF DATABASE 2 IN X AND Y, AND GOTO RDBASEA TO START LOADING LETTERS
	LDY #>DATABASE2
	STA ZPADDR+2		;STORE THE REMAINDER OF A IN $02. SO IF IT NEEDS TO LOAD WORD 16, IT WILL LOAD 6 WORDS IN DATABASE2 TO GET THE 16TH WORD
	JMP RDBASEA			;JUMP TO RDBASEA INSTEAD OF BRANCH BECAUSE WE'RE UNSURE OF FLAGS.
RDBASE3
	LDX #<DATABASE3		;LOAD THE ADRESS OF DATABASE 3 IN X AND Y, AND GOTO RDBASEA TO START LOADING LETTERS
	LDY #>DATABASE3
	STA ZPADDR+2		;STORE THE REMAINDER OF A IN $02. SO IF IT NEEDS TO LOAD WORD 26, IT WILL LOAD 6 WORDS IN DATABASE 2 TO GET THE 26TH WORD
	JMP RDBASEA			;JUMP TO RDBASEA INSTEAD OF BRANCH BECAUSE WE'RE UNSURE OF FLAGS.
RDBASE4
	LDX #<DATABASE4		;LOAD THE ADRESS OF DATABASE 4 IN X AND Y, AND GOTO RDBASEA TO START LOADING LETTERS
	LDY #>DATABASE4
	STA ZPADDR+2		;STORE THE REMAINDER OF A IN $02. SO IF IT NEEDS TO LOAD WORD 36, IT WILL LOAD 6 WORDS IN DATABASE 2 TO GET THE 36TH WORD
	JMP RDBASEA			;JUMP TO RDBASEA INSTEAD OF BRANCH BECAUSE WE'RE UNSURE OF FLAGS.	
RDBASE5
	LDX #<DATABASE5		;LOAD THE ADRESS OF DATABASE 5 IN X AND Y, AND GOTO RDBASEA TO START LOADING LETTERS
	LDY #>DATABASE5
	STA ZPADDR+2		;STORE THE REMAINDER OF A IN $02. SO IF IT NEEDS TO LOAD WORD 46, IT WILL LOAD 6 WORDS IN DATABASE 2 TO GET THE 46TH WORD
	
RDBASEA	
	STX ZPADDR			;TEMP STORE START MEM ADRES OF TEXT IN $30 AND $31
	STY ZPADDR+1
	LDA #0
	STA ZPADDR+4		;RESET $04 TO 0 BEFORE CONTINUEING
	
	LDY #0				;RESET Y FOR LOOPING THROUGH THE LETTERS IN THE WORDS
	LDX #1				;RESET X FOR LOOPING THROUGH THE WORDS IN THE DATABASE
	
RDBASEB 
	LDA (ZPADDR),Y		;LOAD A STRING CHARACTER FROM ADDRESS STORED IN POINTER ZPADDR AND ZPADDR+1 ($30 AND $31 IN THIS CASE)
	STY ZPADDR+3		;STORE Y IN $03 FOR NOW
	STA ZPADDR+5		;STORE A IN $05 FOR NOW
	TYA					;LOAD Y INTO A
	SEC
	SBC ZPADDR+4		;SUBTRACT A (WHICH IS THE AMOUNT OF LETTERS IN Y) BY THE AMOUNT IN $04 (LETTERS FROM PREVIOUS WORDS)

	CPX #1				;CHECK IF THIS IS THE FIRST WORD READ, IF SO, SKIP OVER THE SUBTRACT 1 PART AS THIS WORD DOESNT HAVE THIS PROBLEM
	BEQ RDBASEB1		
	SEC
	SBC #1				;NOW SUBTRACT 1 MORE, BECAUSE OF THE 0 AT THE END OF THE WORD WILL CAUSE A OFFSET OF 0 WHEN READING THE NEXT WORD
RDBASEB1
	TAY					;RETURN THE VALUE OF A TO Y
	LDA ZPADDR+5		;RELOAD A FROM $05
	STA VAR_AS,Y		;STORE THE LETTER IN VAR_AS, OFFSET BY Y (ALSO STORE 0 IF YOU GET TO THAT)
	LDY ZPADDR+3		;RELOAD Y FROM $03
	CMP #255
	BEQ RDBASEC			;IF EQUAL TO 255, DONE READING WORD
	INY					;NEXT LETTER
	BNE RDBASEB			;ALWAYS JUMP, WE USE BNE BECAUSE ZERO FLAG WILL NOT BE SET, INY WILL NEVER GET TO 0
RDBASEC
	
	CPX ZPADDR+2		;IF THE WORD READ IS THE NUMBER OF THE AMOUNT OF WORDS TO ACTUALLY READ
	BEQ RDBASEY			;THEN DONE READING DATABASE, EXIT SUBROUTINE
	STY ZPADDR+4		;STORE THE AMOUNT OF LETTERS ALREADY READ IN $04
	INX					;IF NOT, NEXT WORD!
	INY
	BNE RDBASEB			;ALWAYS JUMP, WE USE BNE BECAUSE ZERO FLAG WILL NOT BE SET, INY WILL NEVER GET TO 0
RDBASEY					;SUBROUTINE TERMINATOR (GO BACK WHERE YOU CAME FROM BEFORE!)
	RTS
RDBASEZ					;JUST SKIPPING OVER FUNCTION, NO RTS OTHERWISE BACK TO PROMPT!

;---------------------------------------------
;FUNCTION - LEN SIMULATION, START AT A 16-BIT MEM VALUE (IN X AND Y), UNTIL A 0 IS FOUND, RETURNS RESULT IN A
;---------------------------------------------
;NORMALLY SKIP OVER THIS FUNCTION
	CLV 				;CLEAR OVERFLOW FLAG
	BVC LENZ			;BRANCH ON OVERFLOW CLEAR (WHICH IT ALWAYS IS!)
LEN
	STX ZPADDR			;TEMP STORE START MEM ADRES OF VARIABLE IN $30 AND $31
	STY ZPADDR+1
	LDY #0				;RESET Y FOR LOOPING THROUGH THE STRING
LENA 
	LDA (ZPADDR),Y		;LOAD A STRING CHARACTER FROM ADDRESS STORED IN POINTER ZPADDR AND ZPADDR+1 ($30 AND $31 IN THIS CASE)
	CMP #255
	BEQ LENY			;IF EQUAL TO 0, DONE COUNTING CHARACTERS
	INY					;IF NOT 0 THEN INCREMENT LETTERS IN VAR BY 1
	BNE LENA			;ALWAYS JUMP, WE USE BNE BECAUSE INY SHOULD NEVER REACH 0
LENY
	TYA					;TRANSFER THE RESULT TO A AND DONE!
	RTS
LENZ

;---------------------------------------------	
;THE TEXT USED IN THE GAME
;---------------------------------------------
OPENA		BYTE	$E0,"HANGMAN",255
ASKNUM		BYTE	$E2,"PLEASE ENTER THE DATE: ",255
DIDWORDS	BYTE	$EA,"YOU DID ALL THE WORDS!",255
LETTERSUSED	BYTE	$E2,"HERE ARE THE LETTERS YOU USED: ",CR,255
LGUESS		BYTE 	$EA,"WHAT IS YOUR GUESS: ",255
LGUESSW		BYTE 	$EA,"WHAT IS YOUR GUESS FOR THE WORD:",CR,255
LGUESSED	BYTE	$E7,"YOU GUESSED THAT LETTER BEFORE!",255
PERROR		BYTE	$E7,"PROGRAM ERROR. RUN AGAIN.",255
WRONGWORD	BYTE 	$E7,"WRONG. TRY ANOTHER LETTER.",255
RIGHTWORD1	BYTE	$E7,"RIGHT!! IT TOOK YOU ",255
RIGHTWORD2	BYTE	"GUESSES!",255
ANOTHERWORD	BYTE	$EB,"WANT ANOTHER WORD? (Y/N) ",255
BYE1		BYTE	$EB,"IT'S BEEN FUN! BYE FOR NOW.",255
FOUNDWORD	BYTE	$EA,"YOU FOUND THE WORD!",CR,255
WRONGLET	BYTE	$E7,"SORRY, THAT LETTER ISN'T IN THE WORD.",255
HANG1		BYTE 	$E7,"FIRST WE DRAW A HEAD",255
HANG2		BYTE 	$E7,"NOW WE DRAW A BODY.",255
HANG3		BYTE 	$E7,"NEXT WE DRAW AN ARM.",255
HANG4		BYTE 	$E7,"THIS TIME IT'S THE OTHER ARM.",255
HANG5		BYTE 	$E7,"NOW, LET'S DRAW THE RIGHT LEG.",255
HANG6		BYTE 	$E7,"THIS TIME WE DRAW THE LEFT LEG.",255
HANG7		BYTE 	$E7,"NOW WE PUT UP A HAND.",255
HANG8		BYTE 	$E7,"NEXT THE OTHER HAND.",255
HANG9		BYTE 	$E7,"NOW WE DRAW ONE FOOT",255
HANG10		BYTE 	$E7,"HERE'S THE OTHER FOOT -- YOU'RE HUNG!!",255
LOSE		BYTE	$E9,"SORRY, YOU LOSE. THE WORD WAS:",CR,255
DOYOUWANT	BYTE	$EB,"YOU MISSED THAT ONE. DO YOU ",255

DATABASE1	BYTE	"GUN",255,"SIN",255,"FOR",255,"CRY",255,"LUG",255,"BYE",255,"FLY",255,"UGLY",255,"EACH",255,"FROM",255
DATABASE2	BYTE	"WORK",255,"TALK",255,"WITH",255,"SELF",255,"PIZZA",255,"THING",255,"FEIGN",255,"FIEND",255,"ELBOW",255,"FAULT",255
DATABASE3	BYTE 	"DIRTY",255,"BUDGET",255,"SPIRIT",255,"QUANT",255,"MAIDEN",255,"ESCORT",255,"PICKAX",255,"EXAMPLE",255,"TENSION",255,"QUINIE",255
DATABASE4	BYTE	"KIDNEY",255,"REPLICA",255,"SLEEPER",255,"TRIANGLE",255,"KANGAROO",255,"MAHOGANY",255,"SERGEANT",255,"SEQUENCE",255,"MOUSTACHE",255,"DANGEROUS",255
DATABASE5	BYTE	"SCIENTIST",255,"DIFFERENT",255,"QUIESCENT",255,"MAGISTRATE",255,"ERRONEOUSLY",255,"LOUDSPEAKER",255,"PHYTOTOXIC",255,"MATRIMONIAL",255,"PARASYMPATHOKINETIC",255,"THIGNOTROPISM",255

BitmapFont:
	incbin "\resall\Font96.FNT"
	
palette:
	;	-RGB
	dw $0008	;Dark blue
	dw $0FF0	;Yellow
	dw $00FF	;Cyan
	dw $0F00	;Red
	dw $0001
	dw $0002
	dw $0003
	dw $0004
	dw $0005
	dw $0006
	dw $0007
	dw $0008
	dw $0009
	dw $000A
	dw $000B
	dw $000C
	dw $000D
	dw $000E
	dw $000F
	dw $0010
	dw $0020
	dw $0030
	dw $0040
	dw $0050
	dw $0060
	dw $0070
	dw $0080
	dw $0090
	dw $00A0
	dw $00B0
	dw $00C0
	dw $00D0
	dw $00E0
	dw $00F0
	dw $0100
	dw $0200
	dw $0300
	dw $0400
	dw $0500
	dw $0600
	dw $0700
	dw $0800
	dw $0900
	dw $0A00
	dw $0B00
	dw $0C00
	dw $0D00
	dw $0E00
	dw $0F00
	dw $0111
	dw $0222
	dw $0333
	dw $0444
	dw $0555
	dw $0666
	dw $0777
	dw $0888
	dw $0999
	dw $0AAA
	dw $0BBB
	dw $0CCC
	dw $0DDD
	dw $0EEE
	dw $0FFF
